package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IJavaElement;

import abc.weaving.aspectinfo.Aspect;
import ca.mcgill.sable.abc.impact.visualizer.actions.RunImpactAnalysisActionDelegate;
import ca.mcgill.sable.abc.impact.visualizer.util.ImpactPluginUtil;

public final class AspectTreeNode extends AbstractTreeNode 
	implements IActJavaElement, IProvideJavaElementImage, IProvideJavaElementText {

	private final Aspect aspect;
	private final IJavaElement jEle;
	
	public AspectTreeNode(ITreeNode parent, final Aspect aspect) {
		super(parent);
		this.aspect = aspect;
		this.name = aspect.getName().substring(aspect.getName().lastIndexOf(".")+1);
		this.image = ImageFactory.ASPECT.getImage();
		this.jEle = ImpactPluginUtil.findAjType(
				RunImpactAnalysisActionDelegate.getCurrentProject(), 
				aspect.getName());
	}

	public Aspect getAspect() {
		return aspect;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

	public IJavaElement getJavaElement() {
		return jEle;
	}
}
